# -*- encoding: utf-8 -*-

Gem::Specification.new do |s|
  s.name = %q{sequel}
  s.version = "3.19.0"

  s.required_rubygems_version = Gem::Requirement.new(">= 0") if s.respond_to? :required_rubygems_version=
  s.authors = ["Jeremy Evans"]
  s.date = %q{2011-01-03}
  s.default_executable = %q{sequel}
  s.description = %q{The Database Toolkit for Ruby}
  s.email = %q{code@jeremyevans.net}
  s.executables = ["sequel"]
  s.extra_rdoc_files = ["README.rdoc", "CHANGELOG", "MIT-LICENSE", "doc/advanced_associations.rdoc", "doc/cheat_sheet.rdoc", "doc/dataset_filtering.rdoc", "doc/opening_databases.rdoc", "doc/prepared_statements.rdoc", "doc/reflection.rdoc", "doc/sharding.rdoc", "doc/sql.rdoc", "doc/virtual_rows.rdoc", "doc/dataset_basics.rdoc", "doc/association_basics.rdoc", "doc/querying.rdoc", "doc/migration.rdoc", "doc/validations.rdoc", "doc/model_hooks.rdoc", "doc/active_record.rdoc", "doc/release_notes/1.0.txt", "doc/release_notes/1.1.txt", "doc/release_notes/1.3.txt", "doc/release_notes/1.4.0.txt", "doc/release_notes/1.5.0.txt", "doc/release_notes/2.0.0.txt", "doc/release_notes/2.1.0.txt", "doc/release_notes/2.10.0.txt", "doc/release_notes/2.11.0.txt", "doc/release_notes/2.12.0.txt", "doc/release_notes/2.2.0.txt", "doc/release_notes/2.3.0.txt", "doc/release_notes/2.4.0.txt", "doc/release_notes/2.5.0.txt", "doc/release_notes/2.6.0.txt", "doc/release_notes/2.7.0.txt", "doc/release_notes/2.8.0.txt", "doc/release_notes/2.9.0.txt", "doc/release_notes/3.0.0.txt", "doc/release_notes/3.1.0.txt", "doc/release_notes/3.2.0.txt", "doc/release_notes/3.3.0.txt", "doc/release_notes/3.4.0.txt", "doc/release_notes/3.5.0.txt", "doc/release_notes/3.6.0.txt", "doc/release_notes/3.7.0.txt", "doc/release_notes/3.8.0.txt", "doc/release_notes/3.9.0.txt", "doc/release_notes/3.10.0.txt", "doc/release_notes/3.11.0.txt", "doc/release_notes/3.12.0.txt", "doc/release_notes/3.13.0.txt", "doc/release_notes/3.14.0.txt", "doc/release_notes/3.15.0.txt", "doc/release_notes/3.16.0.txt", "doc/release_notes/3.17.0.txt", "doc/release_notes/3.18.0.txt", "doc/release_notes/3.19.0.txt"]
  s.files = ["MIT-LICENSE", "CHANGELOG", "README.rdoc", "Rakefile", "bin/sequel", "doc/advanced_associations.rdoc", "doc/cheat_sheet.rdoc", "doc/dataset_filtering.rdoc", "doc/opening_databases.rdoc", "doc/prepared_statements.rdoc", "doc/reflection.rdoc", "doc/release_notes/1.0.txt", "doc/release_notes/1.1.txt", "doc/release_notes/1.3.txt", "doc/release_notes/1.4.0.txt", "doc/release_notes/1.5.0.txt", "doc/release_notes/2.0.0.txt", "doc/release_notes/2.1.0.txt", "doc/release_notes/2.10.0.txt", "doc/release_notes/2.11.0.txt", "doc/release_notes/2.12.0.txt", "doc/release_notes/2.2.0.txt", "doc/release_notes/2.3.0.txt", "doc/release_notes/2.4.0.txt", "doc/release_notes/2.5.0.txt", "doc/release_notes/2.6.0.txt", "doc/release_notes/2.7.0.txt", "doc/release_notes/2.8.0.txt", "doc/release_notes/2.9.0.txt", "doc/release_notes/3.0.0.txt", "doc/release_notes/3.1.0.txt", "doc/release_notes/3.2.0.txt", "doc/release_notes/3.3.0.txt", "doc/release_notes/3.4.0.txt", "doc/release_notes/3.5.0.txt", "doc/release_notes/3.6.0.txt", "doc/release_notes/3.7.0.txt", "doc/release_notes/3.8.0.txt", "doc/release_notes/3.9.0.txt", "doc/release_notes/3.10.0.txt", "doc/release_notes/3.11.0.txt", "doc/release_notes/3.12.0.txt", "doc/release_notes/3.13.0.txt", "doc/release_notes/3.14.0.txt", "doc/release_notes/3.15.0.txt", "doc/release_notes/3.16.0.txt", "doc/release_notes/3.17.0.txt", "doc/release_notes/3.18.0.txt", "doc/release_notes/3.19.0.txt", "doc/sharding.rdoc", "doc/sql.rdoc", "doc/virtual_rows.rdoc", "doc/dataset_basics.rdoc", "doc/association_basics.rdoc", "doc/querying.rdoc", "doc/migration.rdoc", "doc/validations.rdoc", "doc/model_hooks.rdoc", "doc/active_record.rdoc", "spec/adapters/firebird_spec.rb", "spec/adapters/informix_spec.rb", "spec/adapters/mssql_spec.rb", "spec/adapters/mysql_spec.rb", "spec/adapters/oracle_spec.rb", "spec/adapters/postgres_spec.rb", "spec/adapters/spec_helper.rb", "spec/adapters/sqlite_spec.rb", "spec/core/connection_pool_spec.rb", "spec/core/core_sql_spec.rb", "spec/core/database_spec.rb", "spec/core/dataset_spec.rb", "spec/core/expression_filters_spec.rb", "spec/core/object_graph_spec.rb", "spec/core/schema_generator_spec.rb", "spec/core/schema_spec.rb", "spec/core/spec_helper.rb", "spec/core/version_spec.rb", "spec/extensions/active_model_spec.rb", "spec/extensions/association_dependencies_spec.rb", "spec/extensions/association_proxies_spec.rb", "spec/extensions/blank_spec.rb", "spec/extensions/boolean_readers_spec.rb", "spec/extensions/caching_spec.rb", "spec/extensions/class_table_inheritance_spec.rb", "spec/extensions/force_encoding_spec.rb", "spec/extensions/hook_class_methods_spec.rb", "spec/extensions/identity_map_spec.rb", "spec/extensions/inflector_spec.rb", "spec/extensions/instance_hooks_spec.rb", "spec/extensions/lazy_attributes_spec.rb", "spec/extensions/looser_typecasting_spec.rb", "spec/extensions/migration_spec.rb", "spec/extensions/many_through_many_spec.rb", "spec/extensions/named_timezones_spec.rb", "spec/extensions/nested_attributes_spec.rb", "spec/extensions/optimistic_locking_spec.rb", "spec/extensions/pagination_spec.rb", "spec/extensions/pretty_table_spec.rb", "spec/extensions/query_spec.rb", "spec/extensions/schema_dumper_spec.rb", "spec/extensions/schema_spec.rb", "spec/extensions/serialization_spec.rb", "spec/extensions/single_table_inheritance_spec.rb", "spec/extensions/spec_helper.rb", "spec/extensions/sql_expr_spec.rb", "spec/extensions/string_date_time_spec.rb", "spec/extensions/subclasses_spec.rb", "spec/extensions/tactical_eager_loading_spec.rb", "spec/extensions/thread_local_timezones_spec.rb", "spec/extensions/timestamps_spec.rb", "spec/extensions/touch_spec.rb", "spec/extensions/typecast_on_load_spec.rb", "spec/extensions/validation_class_methods_spec.rb", "spec/extensions/validation_helpers_spec.rb", "spec/extensions/composition_spec.rb", "spec/extensions/rcte_tree_spec.rb", "spec/extensions/instance_filters_spec.rb", "spec/extensions/sharding_spec.rb", "spec/extensions/skip_create_refresh_spec.rb", "spec/extensions/string_stripper_spec.rb", "spec/extensions/update_primary_key_spec.rb", "spec/extensions/association_pks_spec.rb", "spec/extensions/json_serializer_spec.rb", "spec/extensions/list_spec.rb", "spec/extensions/tree_spec.rb", "spec/extensions/xml_serializer_spec.rb", "spec/extensions/to_dot_spec.rb", "spec/integration/associations_test.rb", "spec/integration/database_test.rb", "spec/integration/dataset_test.rb", "spec/integration/eager_loader_test.rb", "spec/integration/model_test.rb", "spec/integration/plugin_test.rb", "spec/integration/prepared_statement_test.rb", "spec/integration/schema_test.rb", "spec/integration/spec_helper.rb", "spec/integration/timezone_test.rb", "spec/integration/transaction_test.rb", "spec/integration/type_test.rb", "spec/integration/migrator_test.rb", "spec/model/association_reflection_spec.rb", "spec/model/associations_spec.rb", "spec/model/base_spec.rb", "spec/model/dataset_methods_spec.rb", "spec/model/eager_loading_spec.rb", "spec/model/hooks_spec.rb", "spec/model/inflector_spec.rb", "spec/model/model_spec.rb", "spec/model/plugins_spec.rb", "spec/model/record_spec.rb", "spec/model/spec_helper.rb", "spec/model/validations_spec.rb", "spec/rcov.opts", "spec/spec_config.rb.example", "spec/spec_config.rb", "spec/files/bad_down_migration/001_create_alt_basic.rb", "spec/files/bad_down_migration/002_create_alt_advanced.rb", "spec/files/bad_timestamped_migrations/1273253849_create_sessions.rb", "spec/files/bad_timestamped_migrations/1273253851_create_nodes.rb", "spec/files/bad_timestamped_migrations/1273253853_3_create_users.rb", "spec/files/bad_up_migration/001_create_alt_basic.rb", "spec/files/bad_up_migration/002_create_alt_advanced.rb", "spec/files/convert_to_timestamp_migrations/001_create_sessions.rb", "spec/files/convert_to_timestamp_migrations/002_create_nodes.rb", "spec/files/convert_to_timestamp_migrations/003_3_create_users.rb", "spec/files/convert_to_timestamp_migrations/1273253850_create_artists.rb", "spec/files/convert_to_timestamp_migrations/1273253852_create_albums.rb", "spec/files/duplicate_integer_migrations/001_create_alt_advanced.rb", "spec/files/duplicate_integer_migrations/001_create_alt_basic.rb", "spec/files/duplicate_timestamped_migrations/1273253849_create_sessions.rb", "spec/files/duplicate_timestamped_migrations/1273253853_create_nodes.rb", "spec/files/duplicate_timestamped_migrations/1273253853_create_users.rb", "spec/files/integer_migrations/001_create_sessions.rb", "spec/files/integer_migrations/002_create_nodes.rb", "spec/files/integer_migrations/003_3_create_users.rb", "spec/files/interleaved_timestamped_migrations/1273253849_create_sessions.rb", "spec/files/interleaved_timestamped_migrations/1273253850_create_artists.rb", "spec/files/interleaved_timestamped_migrations/1273253851_create_nodes.rb", "spec/files/interleaved_timestamped_migrations/1273253852_create_albums.rb", "spec/files/interleaved_timestamped_migrations/1273253853_3_create_users.rb", "spec/files/missing_integer_migrations/001_create_alt_basic.rb", "spec/files/missing_integer_migrations/003_create_alt_advanced.rb", "spec/files/missing_timestamped_migrations/1273253849_create_sessions.rb", "spec/files/missing_timestamped_migrations/1273253853_3_create_users.rb", "spec/files/timestamped_migrations/1273253849_create_sessions.rb", "spec/files/timestamped_migrations/1273253851_create_nodes.rb", "spec/files/timestamped_migrations/1273253853_3_create_users.rb", "spec/files/uppercase_timestamped_migrations/1273253849_CREATE_SESSIONS.RB", "spec/files/uppercase_timestamped_migrations/1273253851_CREATE_NODES.RB", "spec/files/uppercase_timestamped_migrations/1273253853_3_CREATE_USERS.RB", "spec/files/reversible_migrations/001_reversible.rb", "spec/files/reversible_migrations/002_reversible.rb", "spec/files/reversible_migrations/003_reversible.rb", "spec/files/reversible_migrations/004_reversible.rb", "spec/files/reversible_migrations/005_reversible.rb", "lib/sequel.rb", "lib/sequel/adapters/ado.rb", "lib/sequel/adapters/ado/mssql.rb", "lib/sequel/adapters/amalgalite.rb", "lib/sequel/adapters/db2.rb", "lib/sequel/adapters/dbi.rb", "lib/sequel/adapters/do.rb", "lib/sequel/adapters/do/mysql.rb", "lib/sequel/adapters/do/postgres.rb", "lib/sequel/adapters/do/sqlite.rb", "lib/sequel/adapters/firebird.rb", "lib/sequel/adapters/informix.rb", "lib/sequel/adapters/jdbc.rb", "lib/sequel/adapters/jdbc/h2.rb", "lib/sequel/adapters/jdbc/mssql.rb", "lib/sequel/adapters/jdbc/mysql.rb", "lib/sequel/adapters/jdbc/oracle.rb", "lib/sequel/adapters/jdbc/postgresql.rb", "lib/sequel/adapters/jdbc/sqlite.rb", "lib/sequel/adapters/jdbc/as400.rb", "lib/sequel/adapters/mysql.rb", "lib/sequel/adapters/odbc.rb", "lib/sequel/adapters/odbc/mssql.rb", "lib/sequel/adapters/openbase.rb", "lib/sequel/adapters/oracle.rb", "lib/sequel/adapters/postgres.rb", "lib/sequel/adapters/shared/mssql.rb", "lib/sequel/adapters/shared/mysql.rb", "lib/sequel/adapters/shared/oracle.rb", "lib/sequel/adapters/shared/postgres.rb", "lib/sequel/adapters/shared/progress.rb", "lib/sequel/adapters/shared/sqlite.rb", "lib/sequel/adapters/sqlite.rb", "lib/sequel/adapters/utils/stored_procedures.rb", "lib/sequel/adapters/mysql2.rb", "lib/sequel/adapters/swift.rb", "lib/sequel/adapters/swift/mysql.rb", "lib/sequel/adapters/swift/postgres.rb", "lib/sequel/connection_pool.rb", "lib/sequel/connection_pool/sharded_single.rb", "lib/sequel/connection_pool/sharded_threaded.rb", "lib/sequel/connection_pool/single.rb", "lib/sequel/connection_pool/threaded.rb", "lib/sequel/core.rb", "lib/sequel/core_sql.rb", "lib/sequel/database.rb", "lib/sequel/database/schema_generator.rb", "lib/sequel/database/schema_methods.rb", "lib/sequel/database/connecting.rb", "lib/sequel/database/dataset.rb", "lib/sequel/database/dataset_defaults.rb", "lib/sequel/database/logging.rb", "lib/sequel/database/misc.rb", "lib/sequel/database/query.rb", "lib/sequel/dataset.rb", "lib/sequel/dataset/actions.rb", "lib/sequel/dataset/features.rb", "lib/sequel/dataset/graph.rb", "lib/sequel/dataset/misc.rb", "lib/sequel/dataset/prepared_statements.rb", "lib/sequel/dataset/query.rb", "lib/sequel/dataset/sql.rb", "lib/sequel/dataset/mutation.rb", "lib/sequel/exceptions.rb", "lib/sequel/extensions/blank.rb", "lib/sequel/extensions/inflector.rb", "lib/sequel/extensions/looser_typecasting.rb", "lib/sequel/extensions/migration.rb", "lib/sequel/extensions/named_timezones.rb", "lib/sequel/extensions/pagination.rb", "lib/sequel/extensions/pretty_table.rb", "lib/sequel/extensions/query.rb", "lib/sequel/extensions/schema_dumper.rb", "lib/sequel/extensions/sql_expr.rb", "lib/sequel/extensions/string_date_time.rb", "lib/sequel/extensions/thread_local_timezones.rb", "lib/sequel/extensions/to_dot.rb", "lib/sequel/metaprogramming.rb", "lib/sequel/model.rb", "lib/sequel/model/associations.rb", "lib/sequel/model/base.rb", "lib/sequel/model/default_inflections.rb", "lib/sequel/model/errors.rb", "lib/sequel/model/exceptions.rb", "lib/sequel/model/inflections.rb", "lib/sequel/model/plugins.rb", "lib/sequel/plugins/active_model.rb", "lib/sequel/plugins/association_dependencies.rb", "lib/sequel/plugins/association_proxies.rb", "lib/sequel/plugins/boolean_readers.rb", "lib/sequel/plugins/caching.rb", "lib/sequel/plugins/class_table_inheritance.rb", "lib/sequel/plugins/force_encoding.rb", "lib/sequel/plugins/hook_class_methods.rb", "lib/sequel/plugins/identity_map.rb", "lib/sequel/plugins/instance_hooks.rb", "lib/sequel/plugins/lazy_attributes.rb", "lib/sequel/plugins/many_through_many.rb", "lib/sequel/plugins/nested_attributes.rb", "lib/sequel/plugins/optimistic_locking.rb", "lib/sequel/plugins/schema.rb", "lib/sequel/plugins/serialization.rb", "lib/sequel/plugins/subclasses.rb", "lib/sequel/plugins/single_table_inheritance.rb", "lib/sequel/plugins/tactical_eager_loading.rb", "lib/sequel/plugins/timestamps.rb", "lib/sequel/plugins/touch.rb", "lib/sequel/plugins/typecast_on_load.rb", "lib/sequel/plugins/validation_class_methods.rb", "lib/sequel/plugins/validation_helpers.rb", "lib/sequel/plugins/composition.rb", "lib/sequel/plugins/rcte_tree.rb", "lib/sequel/plugins/instance_filters.rb", "lib/sequel/plugins/sharding.rb", "lib/sequel/plugins/skip_create_refresh.rb", "lib/sequel/plugins/string_stripper.rb", "lib/sequel/plugins/update_primary_key.rb", "lib/sequel/plugins/association_pks.rb", "lib/sequel/plugins/json_serializer.rb", "lib/sequel/plugins/list.rb", "lib/sequel/plugins/tree.rb", "lib/sequel/plugins/xml_serializer.rb", "lib/sequel/sql.rb", "lib/sequel/timezones.rb", "lib/sequel/version.rb", "lib/sequel_core.rb", "lib/sequel_model.rb"]
  s.homepage = %q{http://sequel.rubyforge.org}
  s.rdoc_options = ["--quiet", "--line-numbers", "--inline-source", "--title", "Sequel: The Database Toolkit for Ruby", "--main", "README.rdoc"]
  s.require_paths = ["lib"]
  s.required_ruby_version = Gem::Requirement.new(">= 1.8.4")
  s.rubyforge_project = %q{sequel}
  s.rubygems_version = %q{1.3.7}
  s.summary = %q{The Database Toolkit for Ruby}

  if s.respond_to? :specification_version then
    current_version = Gem::Specification::CURRENT_SPECIFICATION_VERSION
    s.specification_version = 3

    if Gem::Version.new(Gem::VERSION) >= Gem::Version.new('1.2.0') then
    else
    end
  else
  end
end
